scala.collection

# GenTraversableOnce

###
Related Doc: package collection

#### trait GenTraversableOnce[+A] extends Any

A template trait for all traversable-once objects which may be traversed in parallel.

Methods in this trait are either abstract or can be implemented in terms of other methods.

Source
  GenTraversableOnce.scala

Linear Supertypes
Any
Known Subclasses
::, AbstractBuffer, AbstractIterable, AbstractIterable, AbstractIterator, AbstractMap, AbstractMap, AbstractMap, AbstractSeq, AbstractSeq, AbstractSet, AbstractSet, AbstractTraversable, AnyRefMap, Appended, Appended, Appended, Appended, Appended, Appended, ArrayBuffer, ArrayLike, ArrayOps, ArraySeq, ArrayStack, BitSet, BitSet, BitSet, BitSet1, BitSet2, BitSetLike, BitSetN, Buffer, BufferLike, BufferProxy, BufferedIterator, BufferedLineIterator, BufferedSource, Cons, DefaultKeySet, DefaultKeySet, DefaultKeySet, DefaultKeySortedSet, DefaultKeySortedSet, DefaultMap, DefaultMap, DefaultMapModel, DefaultValuesIterable, DefaultValuesIterable, DoubleLinkedList, DoubleLinkedListLike, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, Elements, Elements, Empty, EmptyView, EmptyView, EmptyView, EmptyView, EntryIterator, Exclusive, Filtered, Filtered, Filtered, Filtered, Filtered, FilteredKeys, FilteredKeys, FlatMapped, FlatMapped, FlatMapped, FlatMapped, Forced, Forced, Forced, Forced, GenIterable, GenIterableLike, GenMap, GenMapLike, GenSeq, GenSeqLike, GenSet, GenSetLike, GenTraversable, GenTraversableLike, GroupedIterator, HashMap, HashMap, HashMap1, HashSet, HashSet, HashTrieMap, HashTrieSet, History, ImmutableDefaultKeySet, ImmutableMapAdaptor, ImmutableSetAdaptor, Impl, Inclusive, Inclusive, IndexedSeq, IndexedSeq, IndexedSeq, IndexedSeqLike, IndexedSeqLike, IndexedSeqOptimized, IndexedSeqOptimized, IndexedSeqView, IntMap, Iterable, Iterable, Iterable, IterableForwarder, IterableLike, IterableProxy, IterableProxyLike, IterableSplitter, IterableView, IterableViewLike, Iterator, LineIterator, LinearSeq, LinearSeq, LinearSeq, LinearSeqLike, LinearSeqOptimized, LinkedHashMap, LinkedHashSet, LinkedList, LinkedListLike, List, ListBuffer, ListMap, ListMap, ListSet, LongMap, LongMap, Map, Map, Map, Map, Map1, Map2, Map3, Map4, MapLike, MapLike, MapLike, MapProxy, MapProxy, MapProxy, MapProxyLike, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, MappedValues, MappedValues, MatchIterator, MultiMap, MutableList, Nil, Node, Node, NumericRange, ObservableBuffer, ObservableMap, ObservableSet, OpenHashMap, PagedSeq, ParArray, ParArrayIterator, ParFlatHashTableIterator, ParHashMap, ParHashMap, ParHashMapIterator, ParHashMapIterator, ParHashSet, ParHashSet, ParHashSetIterator, ParHashSetIterator, ParIterable, ParIterable, ParIterable, ParIterableLike, ParMap, ParMap, ParMap, ParMapLike, ParMapLike, ParRange, ParRangeIterator, ParSeq, ParSeq, ParSeq, ParSeqLike, ParSet, ParSet, ParSet, ParSetLike, ParSetLike, ParTrieMap, ParVector, ParVectorIterator, Patched, Patched, Patched, PreciseSplitter, Prepended, Prepended, PriorityQueue, PriorityQueueProxy, Queue, Queue, QueueProxy, Range, ResizableArray, Reversed, Reversed, Reversed, RevertibleHistory, Script, Seq, Seq, Seq, SeqForwarder, SeqLike, SeqLike, SeqProxy, SeqProxyLike, SeqSplitter, SeqView, SeqViewLike, Set, Set, Set, Set1, Set2, Set3, Set4, SetLike, SetLike, SetProxy, SetProxy, SetProxy, SetProxyLike, Sliced, Sliced, Sliced, Sliced, Sliced, SortedMap, SortedMap, SortedMapLike, SortedSet, SortedSet, SortedSet, SortedSetLike, Source, Splitter, Stack, Stack, StackProxy, Stream, StreamIterator, StreamView, StreamViewLike, StringBuilder, StringLike, StringOps, SynchronizedBuffer, SynchronizedMap, SynchronizedPriorityQueue, SynchronizedQueue, SynchronizedSet, SynchronizedStack, SystemProperties, Taken, Taken, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, Transformed, Transformed, Transformed, Transformed, Transformed, Traversable, Traversable, Traversable, TraversableForwarder, TraversableLike, TraversableOnce, TraversableProxy, TraversableProxyLike, TraversableView, TraversableViewLike, TreeMap, TreeSet, TreeSet, TrieMap, UnrolledBuffer, ValueSet, Vector, VectorIterator, WithDefault, WithDefault, WithDefault, WithDefault, WithDefault, WithDefault, WrappedArray, WrappedString, Zipped, Zipped, Zipped, Zipped, Zipped, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ofBoolean, ofBoolean, ofByte, ofByte, ofChar, ofChar, ofDouble, ofDouble, ofFloat, ofFloat, ofInt, ofInt, ofLong, ofLong, ofRef, ofRef, ofShort, ofShort, ofUnit, ofUnit
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. GenTraversableOnce
2. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this collection or iterator.

2. #### abstract def :\[B](z: B)(op: (A, B) ⇒ B): B

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (a :\ 5)(_+_)
       b: Int = 15

       scala> val c = (a :\ 5)((x,y) => x + y)
       c: Int = 15

   B

     the result type of the binary operator.

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this collection or iterator.

3. #### abstract def aggregate[B](z: ⇒ B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

   Aggregates the results of applying an operator to subsequent elements.

   Aggregates the results of applying an operator to subsequent elements.

   This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

   For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

       pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

   Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

   B

     the type of accumulated results

   z

     the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

   seqop

     an operator used to accumulate results within a partition

   combop

     an associative operator used to combine results from different partitions

4. #### abstract def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

5. #### abstract def count(p: (A) ⇒ Boolean): Int

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   p

     the predicate used to test elements.

   returns

     the number of elements satisfying the predicate `p`.

6. #### abstract def exists(pred: (A) ⇒ Boolean): Boolean

7. #### abstract def find(pred: (A) ⇒ Boolean): Option[A]

   Finds the first element of the collection or iterator satisfying a predicate, if any.

   Finds the first element of the collection or iterator satisfying a predicate, if any.

   Note: may not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   pred

     the predicate used to test elements.

   returns

     an option value containing the first element in the collection or iterator that satisfies `p`, or `None` if none exists.

8. #### abstract def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

   Folds the elements of this collection or iterator using the specified associative binary operator.

   Folds the elements of this collection or iterator using the specified associative binary operator.

   The order in which operations are performed on elements is unspecified and may be nondeterministic.

   A1

     a type parameter for the binary operator, a supertype of `A`.

   z

     a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

   op

     a binary operator that must be associative

   returns

     the result of applying fold operator `op` between all the elements and `z`

9. #### abstract def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

         op(...op(z, x_1), x_2, ..., x_n)

     where `x1, ..., xn` are the elements of this collection or iterator.

10. #### abstract def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this collection or iterator.

11. #### abstract def forall(pred: (A) ⇒ Boolean): Boolean

12. #### abstract def foreach[U](f: (A) ⇒ U): Unit

13. #### abstract def getClass(): Class[_]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      Any

14. #### abstract def hasDefiniteSize: Boolean

15. #### abstract def isEmpty: Boolean

    Tests whether the collection or iterator is empty.

    Tests whether the collection or iterator is empty.

    returns

      `true` if the collection or iterator contains no elements, `false` otherwise.

16. #### abstract def isTraversableAgain: Boolean

    Tests whether this collection or iterator can be repeatedly traversed.

    Tests whether this collection or iterator can be repeatedly traversed. Always true for Traversables and false for Iterators unless overridden.

    returns

      `true` if it is repeatedly traversable, `false` otherwise.

17. #### abstract def mkString: String

    Displays all elements of this collection or iterator in a string.

    Displays all elements of this collection or iterator in a string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator follow each other without any separator string.

18. #### abstract def mkString(sep: String): String

    Displays all elements of this collection or iterator in a string using a separator string.

    Displays all elements of this collection or iterator in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

19. #### abstract def mkString(start: String, sep: String, end: String): String

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this collection or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

20. #### abstract def nonEmpty: Boolean

    Tests whether the collection or iterator is not empty.

    Tests whether the collection or iterator is not empty.

    returns

      `true` if the collection or iterator contains at least one element, `false` otherwise.

21. #### abstract def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection or iterator is nonempty.

    Exceptions thrown

      `UnsupportedOperationException` if this collection or iterator is empty.

22. #### abstract def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this collection or iterator is nonempty, `None` otherwise.

23. #### abstract def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

24. #### abstract def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going right to left:

          op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

      where `x1, ..., xn` are the elements of this collection or iterator.

    Exceptions thrown

      `UnsupportedOperationException` if this collection or iterator is empty.

25. #### abstract def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this collection or iterator is nonempty, `None` otherwise.

26. #### abstract def seq: TraversableOnce[A]

27. #### abstract def size: Int

    The size of this collection or iterator.

    The size of this collection or iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      the number of elements in this collection or iterator.

28. #### abstract def toBuffer[A1 >: A]: Buffer[A1]

    Uses the contents of this collection or iterator to create a new mutable buffer.

    Uses the contents of this collection or iterator to create a new mutable buffer.

    Note: will not terminate for infinite-sized collections.

    returns

      a buffer containing all elements of this collection or iterator.

29. #### abstract def toIndexedSeq: immutable.IndexedSeq[A]

    Converts this collection or iterator to an indexed sequence.

    Converts this collection or iterator to an indexed sequence.

    Note: will not terminate for infinite-sized collections.

    returns

      an indexed sequence containing all elements of this collection or iterator.

30. #### abstract def toIterable: GenIterable[A]

    Converts this collection or iterator to an iterable collection.

    Converts this collection or iterator to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

    Note: will not terminate for infinite-sized collections.

    returns

      an `Iterable` containing all elements of this collection or iterator.

31. #### abstract def toIterator: Iterator[A]

    Returns an Iterator over the elements in this collection or iterator.

    Returns an Iterator over the elements in this collection or iterator. Will return the same Iterator if this instance is already an Iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      an Iterator containing all elements of this collection or iterator.

32. #### abstract def toList: List[A]

    Converts this collection or iterator to a list.

    Converts this collection or iterator to a list.

    Note: will not terminate for infinite-sized collections.

    returns

      a list containing all elements of this collection or iterator.

33. #### abstract def toSeq: GenSeq[A]

    Converts this collection or iterator to a sequence.

    Converts this collection or iterator to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

    Note: will not terminate for infinite-sized collections.

    returns

      a sequence containing all elements of this collection or iterator.

34. #### abstract def toSet[A1 >: A]: GenSet[A1]

    Converts this collection or iterator to a set.

    Converts this collection or iterator to a set.

    Note: will not terminate for infinite-sized collections.

    returns

      a set containing all elements of this collection or iterator.

35. #### abstract def toStream: Stream[A]

    Converts this collection or iterator to a stream.

    Converts this collection or iterator to a stream.

    returns

      a stream containing all elements of this collection or iterator.

36. #### abstract def toTraversable: GenTraversable[A]

    Converts this collection or iterator to an unspecified Traversable.

    Converts this collection or iterator to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

    Note: will not terminate for infinite-sized collections.

    returns

      a Traversable containing all elements of this collection or iterator.

37. #### abstract def toVector: Vector[A]

    Converts this collection or iterator to a Vector.

    Converts this collection or iterator to a Vector.

    Note: will not terminate for infinite-sized collections.

    returns

      a vector containing all elements of this collection or iterator.

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from GenTraversableOnce[A] to any2stringadd[GenTraversableOnce[A]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (GenTraversableOnce[A], B)

   Implicit information
     This member is added by an implicit conversion from GenTraversableOnce[A] to ArrowAssoc[GenTraversableOnce[A]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

   [use case] Copies values of this collection or iterator to an array.

   [use case]

   Copies values of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator, beginning at index `start`. Copying will stop once either the end of the current collection or iterator is reached, or the end of the array is reached.

   Note: will not terminate for infinite-sized collections.

   xs

     the array to fill.

   start

     the starting index.

   Full Signature

   #### abstract def copyToArray[B >: A](xs: Array[B], start: Int): Unit

8. #### abstract def copyToArray(xs: Array[A]): Unit

   [use case] Copies values of this collection or iterator to an array.

   [use case]

   Copies values of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator. Copying will stop once either the end of the current collection or iterator is reached, or the end of the array is reached.

   Note: will not terminate for infinite-sized collections.

   xs

     the array to fill.

   Full Signature

   #### abstract def copyToArray[B >: A](xs: Array[B]): Unit

9. #### def ensuring(cond: (GenTraversableOnce[A]) ⇒ Boolean, msg: ⇒ Any): GenTraversableOnce[A]

   Implicit information
     This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: (GenTraversableOnce[A]) ⇒ Boolean): GenTraversableOnce[A]

    Implicit information
      This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean, msg: ⇒ Any): GenTraversableOnce[A]

    Implicit information
      This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean): GenTraversableOnce[A]

    Implicit information
      This member is added by an implicit conversion from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def equals(arg0: Any): Boolean

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Any implementation of this method should be an equivalence relation:

    - It is reflexive: for any instance `x` of type `Any`, `x.equals(x)` should return `true`.
    - It is symmetric: for any instances `x` and `y` of type `Any`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
    - It is transitive: for any instances `x`, `y`, and `z` of type `AnyRef` if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.

    If you override this method, you should verify that your implementation remains an equivalence relation. Additionally, when overriding this method it is usually necessary to override `hashCode` to ensure that objects which are "equal" (`o1.equals(o2)` returns `true`) hash to the same scala.Int. (`o1.hashCode.equals(o2.hashCode)`).

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

14. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from GenTraversableOnce[A] to StringFormat[GenTraversableOnce[A]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

15. #### def hashCode(): Int

    Calculate a hash code value for the object.

    Calculate a hash code value for the object.

    The default hashing algorithm is platform dependent.

    Note that it is allowed for two objects to have identical hash codes (`o1.hashCode.equals(o2.hashCode)`) yet not be equal (`o1.equals(o2)` returns `false`). A degenerate implementation could always return `0`. However, it is required that if two objects are equal (`o1.equals(o2)` returns `true`) that they have identical hash codes (`o1.hashCode.equals(o2.hashCode)`). Therefore, when overriding this method, be sure to verify that the behavior is consistent with the `equals` method.

    returns

      the hash code value for this object.

    Definition Classes
      Any

16. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

17. #### abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this collection or iterator.

    Full Signature

    #### abstract def max[A1 >: A](implicit ord: Ordering[A1]): A

18. #### abstract def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this collection or iterator with the largest value measured by function f.

    Full Signature

    #### abstract def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

19. #### abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this collection or iterator

    Full Signature

    #### abstract def min[A1 >: A](implicit ord: Ordering[A1]): A

20. #### abstract def minBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the smallest value measured by function f.

    [use case]

    Finds the first element which yields the smallest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this collection or iterator with the smallest value measured by function f.

    Full Signature

    #### abstract def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

21. #### abstract def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements in this collection or iterator of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the collection or iterator and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Full Signature

    #### abstract def product[A1 >: A](implicit num: Numeric[A1]): A1

22. #### abstract def sum: A

    [use case] Sums up the elements of this collection.

    [use case]

    Sums up the elements of this collection.

    returns

      the sum of all elements in this collection or iterator of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the collection or iterator and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Full Signature

    #### abstract def sum[A1 >: A](implicit num: Numeric[A1]): A1

23. #### abstract def to[Col[_]]: Col[A]

    [use case] Converts this collection or iterator into another by copying all elements.

    [use case]

    Converts this collection or iterator into another by copying all elements.

    Note: will not terminate for infinite-sized collections.

    Col

      The collection type to build.

    returns

      a new collection containing all elements of this collection or iterator.

    Full Signature

    #### abstract def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, A, Col[A]]): Col[A]

24. #### abstract def toArray: Array[A]

    [use case] Converts this collection or iterator to an array.

    [use case]

    Converts this collection or iterator to an array.

    Note: will not terminate for infinite-sized collections.

    returns

      an array containing all elements of this collection or iterator. An `ClassTag` must be available for the element type of this collection or iterator.

    Full Signature

    #### abstract def toArray[A1 >: A](implicit arg0: ClassTag[A1]): Array[A1]

25. #### abstract def toMap[T, U]: Map[T, U]

    [use case] Converts this collection or iterator to a map.

    [use case]

    Converts this collection or iterator to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

    Note: will not terminate for infinite-sized collections.

    returns

      a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this collection or iterator.

    Full Signature

    #### abstract def toMap[K, V](implicit ev: <:<[A, (K, V)]): GenMap[K, V]

26. #### def toString(): String

    Returns a string representation of the object.

    Returns a string representation of the object.

    The default representation is platform dependent.

    returns

      a string representation of the object.

    Definition Classes
      Any

27. #### def →[B](y: B): (GenTraversableOnce[A], B)

    Implicit information
      This member is added by an implicit conversion from GenTraversableOnce[A] to ArrowAssoc[GenTraversableOnce[A]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Any

### Inherited by implicit conversion any2stringadd from GenTraversableOnce[A] to any2stringadd[GenTraversableOnce[A]]

### Inherited by implicit conversion StringFormat from GenTraversableOnce[A] to StringFormat[GenTraversableOnce[A]]

### Inherited by implicit conversion Ensuring from GenTraversableOnce[A] to Ensuring[GenTraversableOnce[A]]

### Inherited by implicit conversion ArrowAssoc from GenTraversableOnce[A] to ArrowAssoc[GenTraversableOnce[A]]

### Ungrouped